package de.intevation.flys.importer;

import java.util.List;

import de.intevation.flys.model.NamedMainValue;
import de.intevation.flys.model.MainValueType;

import org.hibernate.Session;
import org.hibernate.Query;

public class ImportNamedMainValue
{
    protected ImportMainValueType mainValueType;
    protected String              name;

    protected NamedMainValue      peer;

    public ImportNamedMainValue() {
    }

    public ImportNamedMainValue(
        ImportMainValueType mainValueType,
        String              name
    ) {
        this.mainValueType = mainValueType;
        this.name          = name;
    }

    public ImportMainValueType getMainValueType() {
        return mainValueType;
    }

    public void setMainValueType(ImportMainValueType mainValueType) {
        this.mainValueType = mainValueType;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public NamedMainValue getPeer() {
        if (peer == null) {
            MainValueType type = mainValueType.getPeer();
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery(
                "from NamedMainValue where " +
                "name=:name and type.id=:id");
            query.setString("name", name);
            query.setParameter("id", type.getId());
            List<NamedMainValue> named = query.list();
            if (named.isEmpty()) {
                peer = new NamedMainValue(name, type);
                session.save(peer);
            }
            else {
                peer = named.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
